#ifndef Token_hpp
#define Token_hpp

namespace SoftWire
{
	class Scanner;

	class Token
	{
		friend Scanner;

	public:
		Token();

		virtual ~Token();

		bool isEndOfLine() const;
		virtual bool isIdentifier() const;
		virtual bool isConstant() const;
		virtual bool isPunctuator() const;

		virtual const char *getString() const;
		virtual char getChar() const;
		virtual int getValue() const;
	};

	class Identifier : public Token
	{
	public:
		Identifier(const char *string);

		~Identifier();

		bool isIdentifier() const;

		const char *getString() const;

	private:
		char *string;
	};

	class Constant : public Token
	{
	public:
		Constant(int value);

		bool isConstant() const;

		int getValue() const;

	private:
		int value;
	};

	class Punctuator : public Token
	{
	public:
		Punctuator(char c);

		bool isPunctuator() const;

		char getChar() const;

	private:
		char c;
	};
}

#endif   // Token_hpp